USE [tpch1gcci]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER OFF
GO

create proc [dbo].[acid_dur_tran_com] 
			@o_key		int,
			@l_key		int,
			@delta		int
as
declare	@ototal		money,
	    @new_ototal	money,
	    @quantity	money,
	    @extprice	money,
	    @new_extprice	money,
	    @pkey		int,
	    @skey		int,
	    @tax		money,
	    @disc		money,
	    @cost		money,
	    @rprice		money,
	    @RAND_WAIT		int,
	    @DelayLength	char(8) = '00:00:00'

begin

declare @deadlockretries int -- number of retries in case of deadlock
set @deadlockretries = 120
while (@deadlockretries > 0)
	begin
		begin try
			begin tran T

print ' '
print 'Timestamp before tran:'
select convert(char(30), getdate(),9)

				select	@ototal		= O_TOTALPRICE
				from	ORDERS
				where	O_ORDERKEY	= @o_key

				select	@quantity	= L_QUANTITY,
					    @extprice	= L_EXTENDEDPRICE,
					    @pkey		= L_PARTKEY,
					    @skey		= L_SUPPKEY,
					    @tax		= L_TAX,
					    @disc		= L_DISCOUNT
				from	LINEITEM
				where	L_ORDERKEY	= @o_key and
					    L_LINENUMBER	= @l_key	

				select	@ototal		= @ototal - ROUND((ROUND((@extprice * (1 - @disc)),2,1) * (1 + @tax)),2,1),
					    @rprice		= ROUND((@extprice/@quantity),2,1),
					    @cost		= ROUND((@rprice * @delta),2,1),
					    @new_extprice	= @extprice + @cost,
					    @new_ototal	= ROUND((@new_extprice	 * (1.0 - @disc)),2,1),
					    @new_ototal	= ROUND((@new_ototal * (1.0 + @tax)),2,1),
					    @new_ototal	= @ototal + @new_ototal

				update	LINEITEM
				set 	L_EXTENDEDPRICE	= @new_extprice,
					    L_QUANTITY	= @quantity + @delta
				where	L_ORDERKEY	= @o_key and
					    L_LINENUMBER	= @l_key

				update	ORDERS
				set	    O_TOTALPRICE	= @new_ototal
				where	O_ORDERKEY	= @o_key	

print ' '
print 'Insert Into HISTORY_DUR'
				insert into HISTORY_DUR values(	@pkey,
								@skey,
								@o_key,
								@l_key,
								@delta,
								getdate())

--  ACID BEGIN
print ' '
print 'Timestamp before delay:'
select convert(char(30), getdate(),9)
--  Wait to ensure that transactions are in flight
SELECT	@RAND_WAIT = ROUND((RAND()+ (RAND())*5),0,1)

SELECT	@DelayLength	= CASE @RAND_WAIT	WHEN 0 then '00:00:00'
											WHEN 1 then '00:00:01'
											WHEN 2 then '00:00:02'
											WHEN 3 then '00:00:03'
											WHEN 4 then '00:00:04'
											WHEN 5 then '00:00:05'
											ELSE '00:00:06'
		END
waitfor DELAY @DelayLength
print ' '
print 'Timestamp before commit:'
select convert(char(30), getdate(),9)
--  ACID END


			commit transaction T
			set @deadlockretries = 0

		end try
        begin catch

			print 'Error Number'
			print error_number()
			print 'Transaction State'
			print xact_state()

			-- deadlock exception number is 1205 
			if ( error_number() = 1205 )  
				begin
					set @deadlockretries = @deadlockretries - 1  
				end
			else
				begin
					set @deadlockretries = 0  
				end
    
            if xact_state() <> 0  
                rollback transaction T
        end catch
    end

	select	@rprice 'RPrice',
		@quantity 'Quantity',
		@tax 'Tax',
		@disc 'Discount',
		@extprice 'Extended Price',
		@ototal 'Total'

end



GO


