--  File:	ACID_table.SQL
--		Microsoft TPC-H Benchmark Kit Version 2.14.0-1010
--		Copyright Microsoft, 2010, 2011
--
--  Purpose:	This script creates a table (acid_values) that will contain
--		a set of random values to be use for the ACID tests of
--		the TPC-H benchmark.  The table is populated by a call to a 
--		stored procedure.  The ACID procedures read this table
--		to guarantee random and valid input.  This table includes a unique
--		clustered index to guarantee that all values are unique
--		for each stage of the ACI tests.  If an attempt is made to insert
--		a value that currently exists in the table, the insert errors out and 
--		the values are recalculated and another insert is attempted.
--

--	Check for pre-existing table
if exists ( select name from sysobjects where name = 'acid_values' )
	drop table acid_values

create table acid_values(
acid_test	char(25),
acid_o_key	bigint,
acid_l_key	bigint,
acid_delta	bigint,
acid_part	bigint,
acid_supp	bigint,
seq_num		bigint)

create unique clustered index acid_values_c1
on acid_values(acid_test,acid_o_key,acid_l_key)

