--  File:     DUR_TRAN.SQL
--            Microsoft TPC-H Benchmark Kit Ver. 2.14.0-1010
--            Copyright Microsoft, 2010, 2011

if exists ( select name from sysobjects where name = 'dur_tran' )
	drop procedure dur_tran
go

create proc dur_tran	@counter	int

as

declare @acid_test	char(25),
	@rand_o_key	bigint,
	@rand_l_key	bigint,
	@rand_delta	int


--  Get random values based on the counter passed to the stored proc
select	@rand_o_key	= acid_o_key,
	@rand_l_key	= acid_l_key,
	@rand_delta	= acid_delta
from	acid_values
where	acid_test	= "Consistency_Durability" and
	seq_num		= @counter

select	"Random Values Used",
	@rand_o_key "@RAND_O_KEY",
	@rand_l_key "@RAND_L_KEY",
	@rand_delta "@RAND_DELTA",
	@counter    "SEQ NUMBER"

exec	acid_dur_tran_com	@rand_o_key,
				@rand_l_key,
				@rand_delta

go
