Rem This File creates load and exec files, launch parallel loads, create indexes and launch parallel execs for the RF1 stored procedure
@setlocal ENABLEDELAYEDEXPANSION

setlocal

REM RF stream num
set TPCH_RF_STREAM_NUM=%1

REM output dir 
set TPCH_RUN_NUM=%2

REM Master log comment 
set TPCH_COMMENT_STR=%3


set TPCH_NUM_RF_EXEC_STREAMS=%4
set TPCH_NUM_RF_EXEC_TOTAL=%5
set TPCH_RF_EXEC_BATCH_SIZE=%6
set TPCH_UF_DIR=%7
set TPCH_NUM_RF_LOAD_STREAMS=%8
set TPCH_NUM_RF_LOAD_FILES=%9

set TPCH_OUTPUT_DIR=%TPCH_OUTPUT_DIR_PREFIX%\%TPCH_RUN_NUM%
if not exist %TPCH_OUTPUT_DIR% md %TPCH_OUTPUT_DIR%
set TPCH_MASTERLOG_FILE=%TPCH_OUTPUT_DIR%\%TPCH_MASTERLOG_NAME%
set TPCH_NUM_OF_THREADS=%4


echo !DATE! !TIME! Start: Executing %TPCH_COMMENT_STR%_STREAM_%TPCH_RF_STREAM_NUM% >> %TPCH_MASTERLOG_FILE%

pushd %TPCH_OUTPUT_DIR%

REM launch transaction loads

	echo !DATE! !TIME! Start: launch_parallel_transaction_loads_RF1  >> %TPCH_MASTERLOG_FILE%
	rem call %TPCH_AUTOMATION_CMD_PATH%\RFs\startCollectWrapper.cmd %TPCH_RUN_NUM% %TPCH_COMMENT_STR%_Parallel_loads 
	set TPCH_SEMAPHORE_NAME=Tran.%TPCH_RF_STREAM_NUM%.%TPCH_RUN_NUM%
	start %TPCH_AUTOMATION_CMD_PATH%\WaitForSemaphore.cmd %TPCH_SEMAPHORE_NAME% %TPCH_NUM_OF_THREADS% %TPCH_SEMAPHORE_NAME%_ALL
	set /A LOCAL_CURR_STREAM = 1

:outerLoopLoadRun

	start /MIN %TPCH_AUTOMATION_CMD_PATH%\execSQLFileListSemaphore_BCP.cmd %TPCH_SEMAPHORE_NAME% bulklist_RF1_tran_%TPCH_RF_STREAM_NUM%_%LOCAL_CURR_STREAM%.txt %TPCH_RUN_NUM% no no no

	set /A LOCAL_CURR_STREAM = %LOCAL_CURR_STREAM% + 1
	if %LOCAL_CURR_STREAM% LEQ %TPCH_NUM_OF_THREADS% goto outerLoopLoadRun

	REM wait for all loads to complete 
	%TPCH_AUTOMATION_EXEC%\semaphore -wait %TPCH_SEMAPHORE_NAME%_ALL
	echo !DATE! !TIME! End: launch_parallel_transaction_loads_RF1  >> %TPCH_MASTERLOG_FILE%


REM Drop Tables

REM 	echo !DATE! !TIME! Start: drop_tables_RF1 >> %TPCH_MASTERLOG_FILE%
REM 	call %TPCH_AUTOMATION_CMD_PATH%\execSQLFileList.cmd drop_tables_RF1_%TPCH_RF_STREAM_NUM%.txt %TPCH_RUN_NUM% no no no
REM 	echo !DATE! !TIME! End: drop_tables_RF1 >> %TPCH_MASTERLOG_FILE%


	rem call %TPCH_AUTOMATION_CMD_PATH%\RFs\stopCollectWrapper.cmd %TPCH_RUN_NUM% %TPCH_COMMENT_STR%_Parallel_Execs 
	rem echo !DATE! !TIME! End: launch_parallel_execs_RF1  >> %TPCH_MASTERLOG_FILE%

echo !DATE! !TIME! End: Executing %TPCH_COMMENT_STR%_STREAM_%TPCH_RF_STREAM_NUM% >> %TPCH_MASTERLOG_FILE%

REM sqlcmd -E -i %TPCH_AUTOMATION_SQL%\Dump_Row_Count.sql -o Post_RF1_Row_count_%TPCH_RF_STREAM_NUM%.txt

endlocal
