Rem This File creates load and exec files, launch parallel loads, create indexes and launch parallel execs for the RF2 stored procedure
@setlocal ENABLEDELAYEDEXPANSION

REM RF stream num
set TPCH_RF_STREAM_NUM=%1

REM output dir 
set TPCH_RUN_NUM=%2

REM Master log comment 
set TPCH_COMMENT_STR=%3

set TPCH_NUM_RF_EXEC_STREAMS=%4
set TPCH_NUM_RF_EXEC_TOTAL=%5
set TPCH_RF_EXEC_BATCH_SIZE=%6

REM Vinay Start
set TPCH_UF_DIR=%TPCH_RF_FLATFILE_DIR%
set TPCH_RF_EXECUTION_SET_START=%7
REM set TPCH_RF_EXECUTION_SET=%7
REM Vinay End



set TPCH_NUM_RF_LOAD_STREAMS=%8
set TPCH_NUM_RF_LOAD_FILES=%9






set TPCH_OUTPUT_DIR=%TPCH_OUTPUT_DIR_PREFIX%\%TPCH_RUN_NUM%
if not exist %TPCH_OUTPUT_DIR% md %TPCH_OUTPUT_DIR%
set TPCH_MASTERLOG_FILE=%TPCH_OUTPUT_DIR%\%TPCH_MASTERLOG_NAME%

set TPCH_AUTOMATION_PATH=%TPCH_KIT_DIR%\Setup\CMD_RFs
REM set TPCH_AUTOMATION_CMD_PATH=%TPCH_AUTOMATION_PATH%\cmd
REM set TPCH_AUTOMATION_SQL=%TPCH_AUTOMATION_PATH%\sql
REM set TPCH_AUTOMATION_CONFIG=%TPCH_AUTOMATION_PATH%\config
REM set TPCH_AUTOMATION_EXEC=%TPCH_AUTOMATION_PATH%\execs
REM set TPCH_MASTERLOG_NAME=MasterLog.txt
REM set TPCH_SQL_DIR=%systemdrive%\Program Files\Microsoft SQL Server\SQL14_Prerelease\12.0.1800.103
REM set TPCH_SQL_LOG_DIR=%systemdrive%\Program Files\Microsoft SQL Server\SQL14_Prerelease\12.0.1800.103
REM set TPCH_SQL_START_COMMAND_LINE =-c -E -x -T 834
REM set TPCH_SQL_SHELL=sqlcmd -S . -E -I -b -w 65535 -l 60 -y 0
REM set TPCH_EXEC_WINDOW_COLOR=9F
pushd %TPCH_OUTPUT_DIR%

REM create tables and indexes etc

REM Diff from RF1
echo :setvar totalSegments %TPCH_NUM_RF_LOAD_FILES% > Create_RF2_Tables.sql 
type %TPCH_AUTOMATION_SQL%\RF_templ\Create_RF2_Tables.sql  >> Create_RF2_Tables.sql 
copy %TPCH_AUTOMATION_SQL%\RF_templ\Increment_Update_Set.sql

echo Create_RF2_Tables.sql > create_tables_RF2_%TPCH_RF_STREAM_NUM%.txt

REM echo :setvar totalSegments %TPCH_NUM_RF_LOAD_FILES% > Drop_RF2_Tables.sql
REM type %TPCH_AUTOMATION_SQL%\RF_templ\Drop_RF2_Tables.sql  >> Drop_RF2_Tables.sql 
REM echo Drop_RF2_Tables.sql > drop_tables_RF2_%TPCH_RF_STREAM_NUM%.txt

copy %TPCH_AUTOMATION_SQL%\RF_templ\Create_RF2_Indices_ColSeg_partitioned.sql 
echo Create_RF2_Indices_ColSeg_partitioned.sql > create_indices_RF2_%TPCH_RF_STREAM_NUM%.txt

echo Increment_Update_Set.sql > Increment_Update_Set_RF2_%TPCH_RF_STREAM_NUM%.txt

REM Vinay Start
set TPCH_INPUT_FOLDER=%TPCH_UF_DIR%
REM Vinay End


REM create load files


set /A LOCAL_CURR_STREAM = 1
:outerLoopLoadCreate

	set /A LOCAL_CURR_LOAD = %LOCAL_CURR_STREAM%
	if exist (RF2_Load_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt) del RF2_Load_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt

	:innerLoopLoadCreate

	REM create load file	
	set SET_FILE_NUM=%LOCAL_CURR_LOAD% 



	REM echo :setvar ffLoc %TPCH_UF_DIR%\				 		> load_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_LOAD%.sql
	REM echo :setvar partNo %LOCAL_CURR_LOAD% 						>> load_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_LOAD%.sql
	REM type %TPCH_AUTOMATION_SQL%\RF_templ\Load_RF2_tmpl.sql 				>> load_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_LOAD%.sql

	REM add it to load file list 
	echo load_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_LOAD%.cmd >> RF2_Load_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt
        
	%TPCH_AUTOMATION_EXEC%\GenerateRF2FileNames.exe %TPCH_OUTPUT_DIR% %TPCH_INPUT_FOLDER% %TPCH_RF_STREAM_NUM% %TPCH_SERVER% %TPCH_DATABASE% %TPCH_USER% %TPCH_PASSWORD% %TPCH_RF_EXECUTION_SET% %LOCAL_CURR_LOAD% %TPCH_RF_EXECUTION_SET_START%

	set /A LOCAL_CURR_LOAD = %LOCAL_CURR_LOAD% + %TPCH_NUM_RF_LOAD_STREAMS%	

	

	if %LOCAL_CURR_LOAD% LEQ %TPCH_NUM_RF_LOAD_FILES% goto innerLoopLoadCreate


set /A LOCAL_CURR_STREAM = %LOCAL_CURR_STREAM% + 1
if %LOCAL_CURR_STREAM% LEQ %TPCH_NUM_RF_LOAD_STREAMS% goto outerLoopLoadCreate

REM create exec files

set /A LOCAL_CURR_STREAM = 1
:outerLoopExecCreate

	set /A LOCAL_CURR_EXEC = %LOCAL_CURR_STREAM%
	if exist (RF2_Execute_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt) del RF2_Execute_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt

	:innerLoopExecCreate
	
	REM create exec file	

	echo :setvar currExec %LOCAL_CURR_EXEC%			> exec_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	echo :setvar batchSize %TPCH_RF_EXEC_BATCH_SIZE%		>> exec_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	echo :setvar numParallelExecs %TPCH_NUM_RF_EXEC_STREAMS%	>> exec_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	echo :setvar totalExecs %TPCH_NUM_RF_EXEC_TOTAL%		>> exec_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql

	REM echo set statistics xml on >> exec_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	type %TPCH_AUTOMATION_SQL%\RF_templ\Execute_RF2_tmpl.sql>> exec_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	REM echo set statistics xml off >> exec_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql

	REM add it to exec file list 
	REM Vinay
	echo exec_RF2_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql >> RF2_Execute_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt

	set /A LOCAL_CURR_EXEC = %LOCAL_CURR_EXEC% + %TPCH_NUM_RF_EXEC_STREAMS%
	if %LOCAL_CURR_EXEC% LEQ %TPCH_NUM_RF_EXEC_TOTAL% goto innerLoopExecCreate

set /A LOCAL_CURR_STREAM = %LOCAL_CURR_STREAM% + 1
if %LOCAL_CURR_STREAM% LEQ %TPCH_NUM_RF_EXEC_STREAMS% goto outerLoopExecCreate


endlocal
